/*
              AntiVirus Scanner - Compile Time Configuration
 */

#ifndef CONFIG_H
#define CONFIG_H


/*
 *	Languages (define only one):
 */
#define PROG_LANGUAGE_ENGLISH		1
/* #define PROG_LANGUAGE_SPANISH	2 */
/* #define PROG_LANGUAGE_FRENCH		3 */
/* *incomplete* #define PROG_LANGUAGE_GERMAN	4 */
/* *incomplete* #define PROG_LANGUAGE_ITALIAN	5 */
/* *incomplete* #define PROG_LANGUAGE_DUTCH	6 */
/* *incomplete* #define PROG_LANGUAGE_NORWEGIAN	7 */
/* *incomplete* #define PROG_LANGUAGE_PORTUGUESE	8 */


/*
 *      Program name and version:
 */
#define PROG_NAME			"AVScan"
#define PROG_NAME_FULL			"AntiVirus Scanner"

#define PROG_VERSION			"5.1.1"

#define PROG_VERSION_MAJOR		5
#define PROG_VERSION_MINOR		1
#define PROG_VERSION_RELEASE		1

/*
 *	Program URL:
 */
#define PROG_URL			"http://freshmeat.net/projects/avscan"

/*
 *      Copyright message:
 *
 *	OpenSSL Licensed.
 */
#if defined(PROG_LANGUAGE_SPANISH)
#define PROG_COPYRIGHT	"\
El derecho de autor (C) 1997-2009 WolfPack Entertainment.\n\
Este programa es protegido por leyes internacionales de derecho de autor\n\
y tratados, la distribucin y/o la modificacin de este software en la\n\
infraccin de la OpenSSL License se prohiben estrictamente.\n\
Violators ser procesado a la extensin ms repleta de la ley.\n"
#elif defined(PROG_LANGUAGE_FRENCH)
#define PROG_COPYRIGHT  "\
Dposer (C) 1997-2009 WolfPack Entertainment.\n\
Ce programme est protg par international dpose lois et traits,\n\
distribution et/ou de ce logiciel dans violation du OpenSSL License\n\
strictement est interdit. Violators sera poursuivi  l'tendue plus pleine\n\
de la loi.\n"
#elif defined(PROG_LANGUAGE_GERMAN)
#define PROG_COPYRIGHT  "\
Urheberrecht (C) 1997-2009 WolfPack Entertainment.\n\
Dieses Programm wird von internationalem Urheberrecht Gesetzen und\n\
Vertrgen, Austeilung bzw. nderung dieser Software in bertretung\n\
DER OpenSSL License Erlaubnis streng verboten wird geschtzt.\n\
Verletzer werden zum vollsten Umfang des Gesetzes strafrechtlich\n\
verfolgt werden.\n"
#elif defined(PROG_LANGUAGE_ITALIAN)
#define PROG_COPYRIGHT  "\
Il copyright (C) 1997-2009 WolfPack Entertainment.\n\
Questo programma  protetto dalle leggi di copyright internazionali e\n\
dai trattati, la distribuzione e/o la modifica di questo software nella\n\
violazione dello OpenSSL License  strettamente proibita. Il\n\
Violators sar perseguito all'estensione la pi piena della legge.\n"
#elif defined(PROG_LANGUAGE_DUTCH)
#define PROG_COPYRIGHT  "\
Auteursrecht (C) 1997-2009 WolfPack Entertainment.\n\
Deze programma wordt door internationale auteursrecht wetten en\n\
verdragen, verdeling en/of wijziging van deze software in overtreding\n\
van de OpenSSL License strikt verboden wordt beschermd.\n\
Overtreders zullen te de volste omvang van de wet geprocedeerd worden.\n"
#elif defined(PROG_LANGUAGE_PORTUGUESE)
#define PROG_COPYRIGHT  "\
Os direitos autorais (C) 1997-2009 WolfPack Entertainment.\n\
Este programa  protegido por direitos internacionais leis autorais e\n\
tratados, modificao de e/ou de distribuio deste software em infrao\n\
do OpenSSL License precisamente  proibida. O Violators ser\n\
processado  plena extenso da lei.\n"
#elif defined(PROG_LANGUAGE_NORWEGIAN)
#define PROG_COPYRIGHT  "\
Copyright (C) 1997-2009 WolfPack Entertainment.\n\
Dette programet beskytter av internasjonal copyrightlover og traktater,\n\
distribusjon og/eller modifikasjon av denne programvaren i overtredelse\n\
av OpenSSL License er streng forbudt. Violators tiltalt til den\n\
fulleste omfang av loven.\n"
#else
#define PROG_COPYRIGHT  "\
Copyright (C) 1997-2009 WolfPack Entertainment.\n\
This program is protected by international copyright laws and treaties,\n\
distribution and/or modification of this software in violation of the\n\
OpenSSL License is strictly prohibited. Violators will be prosecuted\n\
to the fullest extent of the law.\n"
#endif


/*
 *	Prefix Directory:
 */
#ifndef PREFIX
# define PREFIX				"/usr"
#endif


/*
 *	CfgList Default Values:
 */
#if defined(HAVE_CLAMAV)
# define AVS_DEF_DB_LOCATION		cl_retdbdir()
#else
# define AVS_DEF_DB_LOCATION		""
#endif

#define AVS_DEF_AVENGINE_SETTING_CPU_PRIORITY	\
					AVS_AVENGINE_CPU_PRIORITY_MEDIUM
#define AVS_DEF_AVENGINE_SETTING_REPORT_ALL_OBJECTS	\
					FALSE
#define AVS_DEF_AVENGINE_SETTING_MAX_SCAN_SIZE	\
					100000000l
#define AVS_DEF_AVENGINE_SETTING_MAX_DIRECTORY_RECURSIONS	\
					16l
#define AVS_DEF_AVENGINE_SETTING_MAX_ARCHIVE_FILES	\
					10000l
#define AVS_DEF_AVENGINE_SETTING_MAX_ARCHIVE_FILE_SIZE	\
					25000000l
#define AVS_DEF_AVENGINE_SETTING_MAX_ARCHIVE_RECURSIONS	\
					16l

#define AVS_DEF_WIN_X			0
#define AVS_DEF_WIN_Y			0
#define AVS_DEF_WIN_SHOW_TOOL_BAR	TRUE
#define AVS_DEF_WIN_SHOW_STATUS_BAR	TRUE


/*
 *	Usage message:
 */
#define PROG_USAGE_MESG  "\
Usage: avscan <path(s)...> [options]\n\
       avscan --scan <path(s)...> [options]\n\
\n\
    The <path(s)...> specifies the full paths to the file(s) and/or\n\
    directory(ies) to scan at startup.\n\
\n\
    The [options] can be any of the following:\n\
\n\
        --recursive             Recurse into subdirectories.\n\
        -r                      Same as --recursive.\n\
        --executables-only      Scan executable files only.\n\
        -x                      Same as --executables-only.\n\
	--ignore-links		Do not scan link destinations.\n\
	-l			Same as --ignore-links.\n\
        --database <path>       Specifies the virus database as <path>,\n\
                                which may be either a virus database\n\
                                file or a virus database directory.\n\
        -db <path>              Same as --database.\n\
\n\
        --cpu-priority <priority>   Sets the CPU priority, valid values\n\
                                are; highest, high, medium, low,\n\
                                lowest.\n\
\n\
        --report-all-objects    Specifies to report all objects that\n\
                                have been scanned to the Results List.\n\
        --no-report-all-objects   Specifies to only report objects that\n\
                                are infected or have problems to the\n\
                                Results List (opposite of\n\
                                --report-all-objects).\n\
\n\
        --max-scan-size <bytes>   Specifies the maximum number of bytes\n\
                                to scan in each file or 0 for no maximum.\n\
        --max-directory-recursions <level>    Specifies the maximum\n\
                                level of subdirectories to recurse into\n\
                                or 0 for no maximum.\n\
        --max-archive-files <n>   Specifies the maximum number of files\n\
                                to scan in each archive or 0 for no\n\
                                maximum.\n\
        --max-archive-file-size <bytes>   Specifies the maximum number\n\
                                of bytes to scan in each archive or 0\n\
                                for no maximum.\n\
        --max-archive-recursions <level>   Specifies the maximum\n\
                                archive recursion level or 0 for no\n\
                                maximum.\n\
\n\
        --help                  Prints this help screen and exits.\n\
        --version               Prints the version information and exits.\n\
\n\
    Return values:\n\
\n\
        0       Success.\n\
        1       Virus detected or general error.\n\
        2       Invalid value.\n\
        3       Systems error or memory allocation error.\n\
        4       User aborted (otherwise no other error).\n\
        5       User responded with \"no\" to a query (otherwise\n\
                no other error).\n\
        6       An identical operation is already in progress.\n\
        7       Reserved.\n\
        8       Segmentation fault.\n\
\n\
        50      Unable to load or initialize the virus database.\n\
        51      An input file has a corrupt format or a format not\n\
                consistent with its extension.\n\
        52      Unsupported object type.\n\
        53      Unable to open an input directory.\n\
        54      Unable to open an input file.\n\
        55      An error occured while reading an input file.\n\
        56      Unable to stat() or lstat() an input file.\n\
        57      Scan of object was incomplete because it would\n\
                otherwise exceed a specified limit.\n\
        58      Reserved.\n\
        59      Scanner subsystem or plugin unable to scan an input\n\
                file.\n\
	60	Unsupported file format.\n\
	61	Unable to lock the virus database directory.\n\
\n\
        99      No virus scanner support compiled.\n\
\n"


/*
 *	Configuration File Characters:
 */
#define CFG_COMMENT_CHAR		'#'
#define CFG_DELIMINATOR_CHAR		'='


/*
 *	Environment Variable Names:
 */
#define ENV_VAR_NAME_BROWSER		"BROWSER"
#define ENV_VAR_NAME_HELPBROWSER	"HELPBROWSER"
#define ENV_VAR_NAME_TMPDIR		"TMPDIR"


/*
 *	File Names & Paths:
 */
#define NAME_FRESHCLAM			"freshclam"



/*
 *	Configuration File Names & Paths:
 */
#ifdef HAVE_LIBENDEAVOUR2
#define AVS_NAME_CONFIGURATION		"avscan.ini"
#define AVS_NAME_SCAN_LIST		"avscan_scan_list.ini"
#define AVS_NAME_LAST_SCAN_RESULTS_LOG	\
					"avscan.log"
#else
#define AVS_NAME_CONFIGURATION		".avscanrc"
#define AVS_NAME_SCAN_LIST		".avscan_scan_list"
#define AVS_NAME_LAST_SCAN_RESULTS_LOG	\
					"avscan.log"
#endif


/*
 *	Widget Names:
 */
#define AVS_WIN_WIDGET_NAME_TOPLEVEL	"avscan-scanner"
#define AVS_WIN_WIDGET_NAME_MENU_BAR	"menu-bar"
#define AVS_WIN_WIDGET_NAME_TOOL_BAR	"tool-bar"
#define AVS_WIN_WIDGET_NAME_ANIMATION_ICON	"animation-icon"
#define AVS_WIN_WIDGET_NAME_NOTEBOOK	"notebook"
#define AVS_WIN_WIDGET_NAME_SCAN_PAGE_TOPLEVEL	\
					"scan-page-toplevel"
#define AVS_WIN_WIDGET_NAME_SCAN_LIST	"scan-list"
#define AVS_WIN_WIDGET_NAME_RESULTS_PAGE_TOPLEVEL	\
					"results-page-toplevel"
#define AVS_WIN_WIDGET_NAME_RESULTS_LIST	\
					"results-list"
#define AVS_WIN_WIDGET_NAME_DATABASE_PAGE_TOPLEVEL	\
					"database-page-toplevel"
#define AVS_WIN_WIDGET_NAME_STATUS_BAR	"status-bar"


/*
 *	DND Infos:
 */
#define DND_INFO_TEXT_PLAIN		0	/* "text/plain" */
#define DND_INFO_TEXT_URI_LIST		1	/* "text/uri-list" */
#define DND_INFO_STRING			2	/* "STRING" */

#define AVS_DND_INFO_SCAN_ITEM		3	/* AVScan/ScanItem */
#define AVS_DND_TARGET_SCAN_ITEM	"AVScan/ScanItem"


/*
 *	List Defaults:
 */
#define AVS_WIN_LIST_ROW_SPACING	20	/* In pixels */
#define AVS_WIN_LIST_PIXMAP_TEXT_SPACING	\
					2	/* In pixels */


#endif	/* CONFIG_H */
